﻿' /*
' * TSSI .NET SMTP Component Demo (VB 2008)
' * 
' * Note: to test your own SMTP account and the received eMails,
' * you may modify the following code that starts with the "MBC" (may be changed) mark in the comment line.
' * 
' * To read the detailed documentation, please visit
' * http://www.AutoMailSender.com/tssi-dotnet-smtp-component/help.htm
' * 
' * © TriSun Software Inc. All rights reserved.
' */

' Imports TDNSC's namespace first.
Imports TSSI.eMail
' Some native members of this namespace will be used in your code.
Imports System.Net.Mail
' The third-party open source proxy library.
Imports Starksoft.Net.Proxy
' Just for the attachments.
Imports System.IO
Imports Microsoft.VisualBasic
Imports System.Windows.Forms
Imports System

Public Class Main

   ' TSMTP instance (used to send eMail via the (E)SMTP protocol).
   Private WithEvents _tsmtp As New TSMTP
   ' TMailMessage instance (the eMail for sending).
   Private _tmm As New TMailMessage

   Private Sub bPlain_Click(ByVal sender As Object, ByVal e As EventArgs) Handles bPlain.Click

      ' Send a plain text message.

      ' Compose your message.
      ComposeEmail()

      '''' Send message.
      ' Initialize the error messages box.
      tbErr.Text = "Error Messages"
      ' Initialize the progress box.
      tbProgress.Text = "Progress"
      '' Set the interface to be busy.
      Cursor.Current = Cursors.WaitCursor
      Me.Enabled = False
      ''
      With _tsmtp
         Try
            If .Connect(.SMTPServer, .SMTPPort) Then
               If .SendMsg(_tmm) Then
                  MsgBox("Sent the plain text message successfully!", MsgBoxStyle.Information)
               Else
                  MsgBox("Failed to send the plain text eMail, " & _
                         "please see the error messages to know the reason.", MsgBoxStyle.Information)
               End If
            End If
         Catch ex As Exception
            ' Display the exception also.
            tbErr.Text = tbErr.Text & vbCrLf & ex.Message
         End Try
         ' Always disconnect from the SMTP server.        
         .Disconnect()
      End With
      '' Set the interface to be normal.
      Cursor.Current = Cursors.Default
      Me.Enabled = True
      ''
      ''''

   End Sub

   Private Sub bRich_Click(ByVal sender As Object, ByVal e As EventArgs) Handles bRich.Click

      ' Send a rich text message.

      '' Compose your message.
      ComposeEmail()
      ' Set as HTML (rich text) email body.
      _tmm.IsBodyHtml = True
      ' The eMail content (plain text).
      _tmm.Body = "<html><body><h2>Hi, this is a test message that sent by " & _
                  "TSSI .NET SMTP Component.</h2><img src=""" & _
                  New DirectoryInfo(Application.StartupPath).Parent.Parent.FullName & _
                  "\atts\testatt.png"" /></body></html>"
      ''

      '''' Send message.
      ' Initialize the error messages box.
      tbErr.Text = "Error Messages"
      ' Initialize the progress box.
      tbProgress.Text = "Progress"
      '' Set the interface to be busy.
      Cursor.Current = Cursors.WaitCursor
      Me.Enabled = False
      ''
      With _tsmtp
         Try
            If .Connect(.SMTPServer, .SMTPPort) Then
               If .SendMsg(_tmm) Then
                  MsgBox("Sent the rich text message successfully!", MsgBoxStyle.Information)
               Else
                  MsgBox("Failed to send the rich text eMail, " & _
                         "please see the error messages to know the reason.", MsgBoxStyle.Information)
               End If
            End If
         Catch ex As Exception
            ' Display the exception also.
            tbErr.Text = tbErr.Text & vbCrLf & ex.Message
         End Try
         ' Always disconnect from the SMTP server.
         .Disconnect()
      End With
      '' Set the interface to be normal.
      Cursor.Current = Cursors.Default
      Me.Enabled = True
      ''
      ''''
   End Sub
   Private Sub bCheck_Click(ByVal sender As Object, ByVal e As EventArgs) Handles bCheck.Click

      ' Check the format of an eMail address.
      ' TMailMessage.CheckAddress() is a shared method, just call it from the class.

      ' The valid one. 
      MsgBox("test@test.com is " & _
             IIf(TMailMessage.CheckAddress("test@test.com"), "valid!", "invalid!").ToString, _
             MsgBoxStyle.Information)

      ' The invalid one.
      MsgBox("test@test..com is " & _
             IIf(TMailMessage.CheckAddress("test@test..com"), "valid!", "invalid!").ToString, _
             MsgBoxStyle.Information)
   End Sub

   Private Sub bAbout_Click(ByVal sender As Object, ByVal e As EventArgs) Handles bAbout.Click

      ' Displays the About box, it contains the program and edition information.

      TSMTP.About()

   End Sub

   Private Sub bTestLogon_Click(ByVal sender As Object, ByVal e As EventArgs) Handles bTestLogon.Click

      ' Test if the given user and password can be used to log on the SMTP server or not.

      ' Initialize the error messages box.
      tbErr.Text = "Error Messages"
      ' Initialize the progress box.
      tbProgress.Text = "Progress"

      '' Set the interface to be busy.
      Cursor.Current = Cursors.WaitCursor
      Me.Enabled = False
      ''
      With _tsmtp
         Try
            If .Connect(.SMTPServer, .SMTPPort) Then
               ' This utility method is used to test if the given user and 
               ' password can be used to log on the SMTP server or not.
               If .TestLogon() Then
                  MsgBox("Connected and logged in to the SMTP server successfully.", _
                         MsgBoxStyle.Information)
               Else
                  MsgBox("Cannot logged on the SMTP server according to your given information.", _
                         MsgBoxStyle.Exclamation)
               End If
            Else
               MsgBox("Cannot connect to the SMTP server according to your given information in your LAN.", _
                      MsgBoxStyle.Exclamation)
            End If
         Catch ex As Exception
            ' Display the exception also.
            tbErr.Text = tbErr.Text & vbCrLf & ex.Message
         End Try
         ' Always disconnect from the SMTP server.
         .Disconnect()
      End With
      '' Set the interface to be normal.
      Cursor.Current = Cursors.Default
      Me.Enabled = True
      ''

   End Sub

   Private Sub Main_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load

      ' Set the connection and authentication information of your TSMTP instance.

      With _tsmtp

         '' Set the proxy server information if necessary.
         ' The host name or IP address of the proxy server.
         '.ProxyHost = "192.168.1.100"
         ' Connection port.
         '.ProxyPort = 1080
         ' Proxy protocol, currently only supports Socks5 - the common SMTP proxy protocol. 
         '.ProxyProtocol = ProxyType.Socks5
         ' User name.
         '.ProxyUser = "myproxyacc"
         ' Password.
         '.ProxyPasswd = "myproxypwd"
         ''

         '' Set the SMTP account information.
         ' MBC: SMTP server.
         .SMTPServer = "smtp.gmail.com"
         ' MBC: SMTP port.
         .SMTPPort = 465
         ' MBC: SMTP account for authentication required SMTP server (most SMTP servers need this).
         .SMTPUser = "mygmail@gmail.com"
         ' MBC: SMTP password for authentication required SMTP server (most SMTP servers need this).
         .SMTPPasswd = "mypasswd"
         ' MBC: Security connection protocol, if you are not sure, please contact the SMTP provider.
         ' It can be SecureProtocol.None and SecureProtocol.TLS also.
         .Protocol = SecureProtocol.SSL
         ''

      End With
   End Sub
   Private Sub TSMTP_ErrorOccurred(ByVal desc As String) Handles _tsmtp.ErrorOccurred

      ' Display the error messages during sending.

      tbErr.Text = tbErr.Text & vbCrLf & vbCrLf & desc

   End Sub

   Private Sub TSMTP_Progress(ByVal id As Integer, ByVal desc As String) Handles _tsmtp.Progress

      ' Display the progress during sending.

      tbProgress.Text = tbProgress.Text & vbCrLf & vbCrLf & id.ToString & " - " & desc

   End Sub
   Private Sub ComposeEmail()

      ' Compose your message.

      With _tmm

         ' Subject.
         .Subject = "A Test Message Sent by TDNSC"

         ' Not a HTML (rich text) email body (default).
         .IsBodyHtml = False

         ' The eMail content (plain text).
         .Body = "Hi, this is a test message that sent by TSSI .NET SMTP Component."

         '' Add the attachments, if there is no attachment, please do not use this property.
         .Attachments.Clear()
         .Attachments.Add(New FileInfo(New DirectoryInfo(Application.StartupPath).Parent.Parent.FullName & _
                                       "\atts\testatt.txt"))
         .Attachments.Add(New FileInfo(New DirectoryInfo(Application.StartupPath).Parent.Parent.FullName & _
                                       "\atts\testatt.png"))
         ' .Attachments.Add ' Add more...
         ''

         ' MBC: Sender's eMail address.
         .Sender = New MailAddress("mygmail@gmail.com")

         ' MBC: This value will displayed in message header (From...) of the received email.
         .From = New MailAddress("mygmail@gmail.com", "From")

         ' MBC: Sets the ReplyTo address for the mail message.
         .ReplyTo = New MailAddress("mygmail@gmail.com", "ReplyTo")

         ' Whether need a read receipt or not, if do not need, please leave it blank.  
         .Receipt = True

         '' MBC: If _tmm.Receipt property is set as True, 
         '' you can specify a different address than _tmm.From to receive the receipt.
         '' You can also leave _tmm.ReceiptReceiver as blank to use _tmm.From address 
         '' to receive the receipt.
         .ReceiptReceiver = New MailAddress("mygmail@gmail.com", "RR")
         ''          

         ' Make the virtual eMailing time if necessary. Format: DDD, d MMM YYYY HH:MI:SS.
         ' .SendTime = "Fri, 4 Jul 2014 14:03:08"

         '' Specifies the priority level for the e-mail message. 
         '' Please uncomment one if necessary. 
         ' .Priority = MailPriority.High
         ' .Priority = MailPriority.Low
         ' Normal is the default value, if you have not priority requirement, 
         ' please leave it blank.
         ' .Priority = MailPriority.Normal
         ''

         '''' Add the receivers.
         '' MBC: [To].
         .To.Clear()
         .To.Add(New MailAddress("yourgmail@gmail.com", "You@Gmail"))
         .To.Add(New MailAddress("yourhotmail@hotmail.com", "You@Hotmail"))
         '.To.Add... ' Add more...
         ''
         '' MBC: [CC].
         .CC.Clear()
         .CC.Add(New MailAddress("hisgmail@gmail.com", "Him@Gmail"))
         .CC.Add(New MailAddress("hishotmail@hotmail.com", "Him@Hotmail"))
         '.CC.Add... ' Add more...
         ''
         '' MBC: [BCC].
         .Bcc.Clear()
         .Bcc.Add(New MailAddress("hergmail@gmail.com", "Her@Gmail"))
         .Bcc.Add(New MailAddress("herHotmail@hotmail.com", "Her@Hotmail"))
         '.Bcc.Add... ' Add more...
         ''
         ''''

      End With
   End Sub
End Class